<?php
namespace Teknisa\EST\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;


class NewCrud {
    
	protected $crudService;
	protected $dataSourceName;
	protected $dataSourceNameToSave  = false;
    /** @var ParameterBag */
    protected $parameterBag;
    /** @var string[] */
    protected $parameterBagColumns = array();
    protected $environment;

    public function __construct($crudService, ParameterBag $parameterBag, $dataSourceManager, $enviroment) {
		$this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $enviroment;
	}

    public function find(DTO\Request $request, DTO\Response $response) {
        //get_class_methods
        $arrKeysToIgnore = array("page", "limit", "in", "dbname");
  
        $conditions = array();
        $method = $request->getMethod();
        $prams = $request->getParameters();
        $route = $request->getRoutePath();
        $userId = $request->getUserId();
        $method = 'POST';
        $dataSource = $prams['dbname'];
        
        //var_dump(get_class_methods($response));die;
        
        foreach($prams as $key => $cond){
            if(!$this->array_some($arrKeysToIgnore, function($toIgnore) use($key){
                return $toIgnore ==  $key;
            })){
                $condToPush = array(
                                "columnName" => $key,
                                "operator" => "=",
                                "value" => $cond
                              );
                array_push($conditions,  $condToPush);
            }
        }
        $this->dataSourceName = str_replace("/newCrud/","/crud/",$route);
        
        $filterCriteria = new FilterCriteria($dataSource,$conditions);
        $newRequest = new Filter($filterCriteria,$method,$this->dataSourceName,$userId);
        
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
        $rows = $dataSet->getRows();
        $response->data = $rows;
        //var_dump($response);die;
        $response->addDataSet($dataSet);
    }
    
    public function array_some(array $array, callable $fn) {
        foreach ($array as $value) {
            if($fn($value)) {
                return true;
            }
        }
        return false;
    }

}