<?php
namespace Teknisa\EST\Modules\EstoqueCego\Controllers;

use Teknisa\EST\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;
use \Teknisa\Libs\Util\DateUtil;
use \Geral\Entities\Paramfilial;

class Est96000DivergenciasInventarioCegoController extends TeknisaCrud {

    protected $dataSourceName = "";
    protected $parameterBagColumns = [];
    protected $dataSourceManager;
    protected $environment;
    protected $crudService;
    protected $service;
    protected $newCode;
    
    protected $nrorg;
    protected $currentTime;
    protected $operador;
    protected $filialLogada;
    
    public function __construct($crudService, $parameterBag, $dataSourceManager, $environment, $validacoesEstoqueService,$Est96000DivergenciasInventarioCegoService,$newCode) {
        $this->crudService = $crudService;
        $this->dataSourceManager = $dataSourceManager;
        $this->validacoesEstoqueService = $validacoesEstoqueService;
        $this->service = $Est96000DivergenciasInventarioCegoService;
        $this->newCode = $newCode;
        
        $this->operador = $environment->getCdOperador();
        $this->nrorg = $environment->getNrOrg();
        $this->filialLogada = $environment->getCdFilial();
        $this->currentTime = $environment->getCurrentTime()->format("d/m/Y H:i:s");
        $this->environment = $environment;
    }
    
    public function find(Filter $request, Response $response) {
        
        try{
            if($request->getRoutePath() == '/getInventoriesDivergencia'){
                $this->dataSourceName = "inventestcego";
                parent::find($request, $response);
                $Inventories = $response->getDataSets()[0]->getRows();
                
                foreach($Inventories as &$Inventory){
                    // get bussiness day info
                    $BusinessDay = $this->VerifyBussinessDay($request, $Inventory);
                    
                    if($Inventory['IDINVGERAAJUSTE'] == 'N' && $Inventory['IDSITUACEITEINV'] == 'R')
                        $Inventory['IDINVGERAAJUSTE'] = 'NR';
                    
                    
                    if(!empty($BusinessDay)){
                        $count = 1;
                        $boPrimeira = true;
                        $boDiaUtil = true;
                        $boInseri = null;
                        
                        while(!empty($BusinessDay)){
                            $BusinessDay = $this->VerifyBussinessDay($request, $Inventory,$count);
                            if(!empty($BusinessDay)){
                                if($boDiaUtil){
                                    $nextDay = $this->AddDaysToDate($Inventory['DTCONTAGEM'],$count);
                                    $boInseri = $this->VerifyDiaNUtil($Inventory, $nextDay);
                                }else $count ++;
                                
                                if($boInseri){
                                    
                                    $Inventory['DTDIAUTIL'] = $Inventory['DTFERIFILI'];
                                    $boPrimeira = false;
                                    $boDiaUtil = false;
                                    $boInseri  = false;
                                }else{
                                   if($boDiaUtil) $count ++;
                                }
                            }else{
                                if($boPrimeira){
                                    $Inventory['DTDIAUTIL'] = $this->AddDaysToDate($Inventory['DTCONTAGEM'],$count);
                                    $boPrimeira = false;
                                }else $count ++;
                            }
                        }
                    }else{
                        $Inventory['DTDIAUTIL'] = $this->AddDaysToDate($Inventory['DTCONTAGEM']);
                    }
                }
                $response->setDataSets(array(new DataSet('getInventoriesDivergencia', $Inventories)));
            }else{
                    
                $conditions = $request->getFilterCriteria()->getConditions();
                    
                // get params on each position
                foreach($conditions as $condition)
                    $paramBag[$condition['columnName']] = $condition['value'];
                    
                // get items row
                $paramsFind = [
                        "CDFILIAL" => $paramBag['CDFILIAL'],
                        "CDALMOXARIFE" => $paramBag['CDALMOXARIFE'],
                        "CDLOCALESTOQ" => $paramBag['CDLOCALESTOQ'],
                        "DTCONTAGEM" => $paramBag['DTCONTAGEM']
                    ];
                $ItemsRows = $this->FindData("iteminventcego_produto", $paramsFind, $request);
                
                //validate each row
                if(!empty($ItemsRows)){
                    
                    // get filial param cost type
                    $paramfilial = Paramfilial::findOneByCdfilialAndNrorg($paramBag['CDFILIAL'], $this->nrorg);

                    $cdtipcustest = $paramfilial->getCdtipcustest();
                    $idordajuinve = $paramfilial->getIdordajuinve();
                    
                    // set withdraw date according to IDORDAJUINVE param
                    $dtreti = $idordajuinve == 'U' ? $this->AddDaysToDate($paramBag['DTCONTAGEM']) : $paramBag['DTCONTAGEM'];
                    
                    //get cost type
                    $CostType = !empty($cdtipcustest) ? $cdtipcustest : 3;
                    
                    //builds description Date field
                    $Contagem = substr($paramBag['DTCONTAGEM'],0,10);
                    $Geracao = substr($paramBag['DTGERACAOINVEST'],0,10);
                    $Aprovacao = substr($paramBag['DTAPROVINVESTCE'],0,10);
                    
                    $descriptionDates = $Contagem ." - Data de Geração: ".$Geracao." - Data de Aprovação: ".$Aprovacao;
                    
                    $items = [
                        'writeOffItems' => [],
                        'ControlItems' => []
                    ];
                    
                    foreach($ItemsRows as $row){
                        //checks stock position
                        $filial = $row['CDFILIAL'];
                        $tipoCusto = $CostType;
                        $produto = $row['CDPRODUTO'];
                        $almoxarifado = $row['CDALMOXARIFE'];
                        $localEstoque = $row['CDLOCALESTOQ'];
                        $lote = $row['NRLOTEESTQ'];
                        $subLote = $row['NRSUBLOTE'];
                        $dtContagem = $row['DTCONTAGEM'];
                        $idperestneg = "S";
                        // data about cost and quantity of the actual product
                        $custoQuantidade = $this->validacoesEstoqueService->consultaCustoQuantidadeProduto(
                            $filial, $produto, $dtContagem, $tipoCusto, $almoxarifado, $localEstoque, $lote, $subLote, $idperestneg
                        );
                        
                        // gets percentage according to qty from real stock and blind stock
                        $estCegoPercent = $custoQuantidade['QTESTOQDIA'] == 0 ? 0 : abs(((($row['QTINVENTESTCEGO'] * 100)/$custoQuantidade['QTESTOQDIA']) - 100));
                        
                        // gets blind stock percentage divergence 
                        $PercDivBlindStock = $this->service->getParperdivestceg($filial,$produto);
                        
                        if($estCegoPercent >= $PercDivBlindStock) {
                            if(abs($row['QTINVENTESTCEGO'] - floatval($custoQuantidade['QTESTOQDIA'])) > 0.00001) {
                                $row['QTDIVER'] = $row['QTINVENTESTCEGO'] - $custoQuantidade['QTESTOQDIA'];
                                $row['VRDIVER'] = $custoQuantidade['VRCUSTOPROD'] * $row['QTDIVER'];
                                $row['DESCRIPTIONDATES'] = $descriptionDates;
                                
                                if($row['QTINVENTESTCEGO'] > $custoQuantidade['QTESTOQDIA']) {
                                    $items['ControlItems'][] = $row;
                                }else 
                                    $items['writeOffItems'][] = $row;
                            }
                        }
                    }
                
                }else throw new \Exception("Não há dados a serem exibidos.",404);
                
                // returns dataSet according to param MODE
                switch($paramBag['MODE']){
                    case "B":
                        $response->setDataSets(array(new DataSet('getItemsDivergencia', $items['writeOffItems'])));
                        break;
                    case "C":
                        $response->setDataSets(array(new DataSet('getItemsDivergencia', $items['ControlItems'])));
                        break;
                    default:
                        $response->setDataSets(array(new DataSet('getItemsDivergencia', $items)));
                        break;
                }
                    
            }
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function actionsManagementHandler(Request $request, Response $response) {
        try {
            $rows = $request->getDataSet()->getRows();
            $params = $request->getParameters();
            $cdfilimovi = $params['InventoryRow']["CDFILIAL"];
            $cdalmoxarife = $params['InventoryRow']["CDALMOXARIFE"];
            $cdlocalestoq = $params['InventoryRow']["CDLOCALESTOQ"];
            $dtcontagem = $params['InventoryRow']["DTCONTAGEM"];
            
            // get params stock
            $paramfilial = Paramfilial::findOneByCdfilialAndNrorg($cdfilimovi, $this->nrorg);

            $cdservbaiestceg = $paramfilial->getCdservbaiestceg();
            $cdtipcustest = $paramfilial->getCdtipcustest();
            $idordajuinve = $paramfilial->getIdordajuinve();
            $cdtpretbxestceg = $paramfilial->getCdtpretbxestceg();
            
            switch($params['action']){
                case 'accept':{
                    if($params['hasItems']){
                        
                        if(!empty($cdservbaiestceg)){
                            //gets cost type
                            $CostType = !empty($cdtipcustest) ? $cdtipcustest : 3;
                            
                             //adds one day on DTPROCESSA 
                            $NextDay = $this->AddDaysToDate($dtcontagem);
                            
                            // sets withdraw date according to IDORDAJUINVE param
                            $dtreti = $idordajuinve == 'U' ? $NextDay : $dtcontagem;
                            
                            //get cardapio info
                            $CardapioInfo = $this->service->getCardapioInfo($cdfilimovi,$dtreti,$cdservbaiestceg);
                            
                            if(empty($CardapioInfo)){
                                $NrCardapio = $this->geraNewSequencial('CARDADIA', $this->filialLogada);
                                //insert new cardapio
                                $newCadapioData = [
                                    'CDFILIAL' => $cdfilimovi,
                                    'NRCARDAPIO' => $NrCardapio,
                                    'CDSERVFILI' => $cdservbaiestceg,
                                    'CDOPERADOR' => $this->operador,
                                    'DTCARDAPIO' => $dtreti,
                                    'DTMESCARD'  => $dtreti,
                                    "NRORG"         =>  $this->environment->getNrOrgTrab(),
                                    "__is_new"      =>  true
                                ];
                                
                                $this->dataSourceName = 'cardadia';
                                $newRequest = new DTO\Request\Row ($newCadapioData, '', '', '');
                                parent::save($newRequest, $response);
                                
                            }else $NrCardapio = $CardapioInfo['NRCARDAPIO'];
                            
                            //Inserts into lanctoestq
                            $nrlancestq = $this->geraNewSequencial('LANCTOEST', $this->filialLogada);
                            
                            $lanctoestData = [
                                'CDFILIAL'    => $this->filialLogada,
                                'NRLANCESTQ'  => $nrlancestq,
                                'IDTPLANCTO'  => 3, 
                                'DTLANCESTQ'  => $dtreti,
                                'CDFILIMOVI'  => $cdfilimovi,
                                'CDOPERADOR'  => $this->operador,
                                'IDALTCUSMED' => 'N',
                                'DSLANCESTQ'  => '',
                                "NRORG"       => $this->nrorg,
                                "__is_new"    => true
                            ];
                            $this->dataSourceName = 'lanctoestoq';
                            $newRequest = new DTO\Request\Row ($lanctoestData, '', '', '');
                            parent::save($newRequest, $response);
                            
                            //Inserts into retirada
                            $NrRetirada = $this->geraNewSequencial('RETIRADA', $this->filialLogada);
                            
                            $retiradaData = [
                                "CDFILIAL"     => $cdfilimovi,
                                "NRRETIRADA"   => $NrRetirada,
                                "NRCARDAPIO"   => $NrCardapio,
                                "DTRETIRADA"   => $dtreti,
                                "CDFILANCESTQ" => $this->filialLogada,
                                'NRLANCESTQ'   => $nrlancestq,
                                "NRORG"       => $this->nrorg,
                                "__is_new"    => true
                            ];
                            $this->dataSourceName = 'retirada';
                            $newRequest = new DTO\Request\Row ($retiradaData, '', '', '');
                            parent::save($newRequest, $response);
                            
                            //Builds items params for itlanctoest
                            foreach($rows as $item){
                                $Nrseqitem = $this->geraNewSequencial('ITEMRETI', $this->filialLogada ,4);
                                
                                if(isset($item['__groupHeaders']))
                                    unset($item['__groupHeaders']);
                                
                                // Gets product Info
                                $paramsFind = ["CDPRODUTO" => $item['CDPRODUTO']];
                                $productInfo = $this->FindData("produto", $paramsFind, $request)[0];
                                
                                //checks stock position
                                $filial = $item['CDFILIAL'];
                                $tipoCusto = $CostType;
                                $produto = $item['CDPRODUTO'];
                                $almoxarifado = $item['CDALMOXARIFE'];
                                $localEstoque = $item['CDLOCALESTOQ'];
                                $lote = $item['NRLOTEESTQ'];
                                $subLote = $item['NRSUBLOTE'];
                                $dtContagem = $item['DTCONTAGEM'];
                                $idperestneg = "S";
                                
                                $posestdiaInfo = $this->validacoesEstoqueService->consultaCustoQuantidadeProduto(
                                    $filial, $produto, $NextDay, $tipoCusto, $almoxarifado, $localEstoque, $lote, $subLote,$idperestneg
                                );
                                
                                $item['CDFILIMOVI'] = $cdfilimovi;
                                $item['CDFILIAL']   = $this->filialLogada;
                                $item['CDPRODMOVI'] = $productInfo['CDPRODESTO'];
                                $item['NRLANCESTQ']  = $nrlancestq;
                                $item['NRSEQUITEM'] = $Nrseqitem;
                                $item['NRSEQUITRETI'] = $Nrseqitem;
                                $item['IDTIPOMOVI'] = '3';
                                $item['IDEVOLESTOQ'] = 'S';
                                $item['IDORDEMCLC'] = '9';
                                $item['IDALTCMEDMV'] = 'N';
                                $item['CDTIPORETI'] = $cdtpretbxestceg;
                                $item['QTLANCTOEST'] = ($posestdiaInfo['QTESTOQDIA'] - $item['QTINVENTESTCEGO']) * $productInfo['VRFATOCONV'];
                                $item['QTTOTLANCTO'] = $item['QTLANCTOEST'];
                                $item['VRUNILANCTO'] = $posestdiaInfo['VRCUSTOPROD'] * $productInfo['VRFATOCONV'];
                                $item['VRTOTLANCTO'] = $item['VRUNILANCTO'] * $item['QTTOTLANCTO'];
                                $item['NRRETIRADA'] = $NrRetirada;
                                $item['NRCARDAPIO'] = $NrCardapio;
                                $item['QTRETIRADA'] = $item['QTLANCTOEST'];
                                $item['__is_new'] = true;
                            }
                            
                            //Inserts into itlanctoest
                            $newDatasetToSave = new DataSet('itlanctoest', $rows);
                            $newRequestToSave = new DTO\Request\DataSet($newDatasetToSave, '', '', '');
                            $CompletedDataset = $this->crudService->getRowsToSave($newRequestToSave, "itlanctoest");
                            $dataSetToSave = new DataSet("itlanctoest", $CompletedDataset);
                            $this->dataSourceManager->persist($dataSetToSave);
                            
                            //Complete items params for itemreti
                            foreach($rows as $item){
                                $item['CDFIITLANEST'] = $item['CDFILIMOVI'];
                                $item['CDPRODUTO']    = $item['CDPRODMOVI'];
                            }
                            
                            //Inserts into itemreti
                            $newDatasetToSave = new DataSet('itemreti', $rows);
                            $newRequestToSave = new DTO\Request\DataSet($newDatasetToSave, '', '', '');
                            $CompletedDataset = $this->crudService->getRowsToSave($newRequestToSave, "itemreti");
                            $dataSetToSave = new DataSet("itemreti", $CompletedDataset);
                            $this->dataSourceManager->persist($dataSetToSave);
                            
                            //updates Stock deleting irregular items 
                            $this->validacoesEstoqueService->atualizaEstoque($cdfilimovi, $nrlancestq,false,true,false);
                            
                            //updates blind inventory
                            $blindInventoryParams = [
                                "CDOPERADOR"      => $this->operador,
                                "DTRECACEITAJUST" => $this->currentTime,
                                "DSOBSRECAJUST"   => '',
                                "IDSITUACEITEINV" => 'A',
                                "CDFILIAL"        => $cdfilimovi,
                                'CDALMOXARIFE'    => $cdalmoxarife,
                                "CDLOCALESTOQ"    => $cdlocalestoq,
                                "DTCONTAGEM"      => $dtcontagem,
                                "NRORG"           => $this->nrorg,
                                "__is_new"        => false
                            ];
                            
                            $this->dataSourceName = 'inventestcego';
                            $newRequest = new DTO\Request\Row ($blindInventoryParams, '', '', '');
                            parent::save($newRequest, $response);
                        }else{
                            throw new \Exception("Não existe serviço parametrizado para a baixa automática.");
                        }
                    }else{
                        $blindInventoryParams = [
                            "CDOPERADOR"      => $this->operador,
                            "DTRECACEITAJUST" => $this->currentTime,
                            "DSOBSRECAJUST"   => '',
                            "IDSITUACEITEINV" => 'A',
                            "CDFILIAL"        => $cdfilimovi,
                            'CDALMOXARIFE'    => $cdalmoxarife,
                            "CDLOCALESTOQ"    => $cdlocalestoq,
                            "DTCONTAGEM"      => $dtcontagem,
                            "NRORG"           => $this->nrorg,
                            "__is_new"        => false
                        ];
                        
                        $this->dataSourceName = 'inventestcego';
                        $newRequest = new DTO\Request\Row ($blindInventoryParams, '', '', '');
                        parent::save($newRequest, $response);
                    }
                }
                    break;
                case 'refuse':{
                    $blindInventoryParams = [
                        "CDOPERADOR"      => $this->operador,
                        "DTRECACEITAJUST" => $this->currentTime,
                        "DSOBSRECAJUST"   => '',
                        "IDSITUACEITEINV" => 'R',
                        "CDFILIAL"        => $cdfilimovi,
                        'CDALMOXARIFE'    => $cdalmoxarife,
                        "CDLOCALESTOQ"    => $cdlocalestoq,
                        "DTCONTAGEM"      => $dtcontagem,
                        "NRORG"           => $this->nrorg,
                        "__is_new"        => false
                    ];
                    $this->dataSourceName = 'inventestcego';
                    $newRequest = new DTO\Request\Row ($blindInventoryParams, '', '', '');
                    parent::save($newRequest, $response);
                }
                    break;
                case 'adjust':{
                    // Sets withdraw date according to IDORDAJUINVE param
                    $dtreti = $idordajuinve == 'U' ? $this->AddDaysToDate($dtcontagem) : $dtcontagem;
                    
                    // Get cardapio info
                    $CardapioInfo = $this->service->getCardapioInfo($cdfilimovi,substr($dtreti,0,10),$cdservbaiestceg);
                    // Sets NrCardapio
                    $nrCardapio = empty($CardapioInfo) ? $this->geraNewSequencial('CARDADIA', $this->filialLogada) : $CardapioInfo['NRCARDAPIO'];
                    
                    //Gets Items
                    $paramsFind = [
                        "CDFILIAL" => $cdfilimovi,
                        "CDALMOXARIFE" => $cdalmoxarife,
                        "CDLOCALESTOQ" => $cdlocalestoq,
                        "DTCONTAGEM" => $dtcontagem
                    ];
                    $productsInfo = $this->FindData("iteminventcego_produto", $paramsFind, $request);
                    
                    //Gets retirada info
                    $paramsFind = [
                        "CDFILIAL" => $cdfilimovi,
                        "CDSERVFILI" => $cdservbaiestceg,
                        "DTRETIRADA" => $dtreti
                    ];
                    $retiradaInfo = $this->FindData("cardadia_retirada", $paramsFind, $request);
                    $statusRetirada = !empty($retiradaInfo) ? "S" : "N";
                    
                    //generate next sequential codes
                    $nrRetirada = $this->geraNewSequencial('retirada', $this->filialLogada);
                    $nrlancestq = $this->geraNewSequencial('LANCTOEST', $this->filialLogada);
                    $nrlancret = $this->geraNewSequencial('LANCTOEST', $this->filialLogada);
                    
                    if(!empty($productsInfo)){
                        //executes procedure GERA_AJUSTE_INVCEGO
                        $date = DateUtil::getDataDeString(substr($dtcontagem,0,10));
                        
                        $this->service->executaProcedureGeraAjusteInvCego(
                            $this->filialLogada,
                            $date->format('d/m/Y'),
                            $cdfilimovi,
                            $cdalmoxarife,
                            $cdlocalestoq,
                            $nrlancestq,
                            $nrlancret,
                            $nrRetirada,
                            $nrCardapio,
                            $this->operador,
                            $statusRetirada
                        );
                    
                        if(!empty($CardapioInfo['CDFILANCESTQ'])){
                            
                            //insert ajuste on table AJURELACRET
                            $AjusteRetParams = [
                                "CDFILIAL"     => $this->filialLogada,
                                "NRLANCESTQ"   => $nrlancestq,
                                "CDFILIALRET"  => $cdfilimovi,
                                "NRLANCESTRET" => $CardapioInfo['NRLANCESTQ'],
                                "NRORG"        => $this->nrorg,
                                "__is_new"     => true
                            ];
                            
                            $this->dataSourceName = 'ajurelacret';
                            $newRequest = new DTO\Request\Row ($AjusteRetParams, '', '', '');
                            parent::save($newRequest, $response);
                        }
                        
                        $blindInventoryParams = [
                            "IDINVGERAAJUSTE" => "S",
                            "IDSITUACEITEINV" => 'A',
                            "DTRECACEITAJUST" => $this->currentTime,
                            "CDFILIAL"        => $cdfilimovi,
                            'CDALMOXARIFE'    => $cdalmoxarife,
                            "CDLOCALESTOQ"    => $cdlocalestoq,
                            "DTCONTAGEM"      => $dtcontagem,
                            "NRORG"           => $this->nrorg,
                            "__is_new"        => false
                        ];
                        
                        $this->dataSourceName = 'inventestcego';
                        $newRequest = new DTO\Request\Row ($blindInventoryParams, '', '', '');
                        parent::save($newRequest, $response);
                    }
                    
                    $returnData = [];
                    
                    //Get Items ajusted info
                    $paramsFind = [
                        "CDFILIAL" => $cdfilimovi,
                        "NRLANCESTQ" => $nrlancestq,
                        "IDEVOLESTOQ" => 'N'
                    ];
                    
                    $returnData['ItemsAjusted'] = $this->FindData("itlanctoest", $paramsFind, $request);
                    
                    //Get Items without cost
                    $itemsWithhoutCost = $this->service->getItemsWithoutCost($cdfilimovi,$cdalmoxarife,$cdlocalestoq,$dtcontagem);
                    
                    $returnData['ItemsWithoutCost'] = $itemsWithhoutCost;
                    
                    $returnData['nrlancestq'] = $nrlancestq;
                    
                    $response->setDataSets(array(new DataSet('ResultData', $returnData)));
                    break;
                }
                default:
                    break;
            }
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function geraNewSequencial($table, $param = '', $colSize = 10) {
        return $this->newCode->getCodeByTableName($table.$param, $this->nrorg, 1, $colSize);
    }
    
    public function VerifyBussinessDay($request, $Inventory, $days = 1) {
        
        $this->dataSourceName = 'ferifili';
        $newFilterCriteria = new FilterCriteria($this->dataSourceName, []);
        
        $newFilterCriteria->addCondition('CDFILIAL', $Inventory['CDFILIAL']);
        $newFilterCriteria->addCondition('DTFERIFILI', $this->AddDaysToDate($Inventory['DTCONTAGEM'],$days));
        
        $filter = new DTO\Request\Filter($newFilterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        $newResponse = new Response();
        parent::find($filter, $newResponse);
        
        return $newResponse->getDataSets()[0]->getRows();
    }
    
    public function AddDaysToDate($date,$days = 1) {
        
        $datetime = DateUtil::getDataDeString(substr($date,0,10));
        $datetime->modify('+'.$days.' day');
        return $datetime->format('d/m/Y');
    }
    
    public function VerifyDiaNUtil($Inventory, $nextDay) {
        $booDia = false;
        $paramfilial = Paramfilial::findOneByCdfilialAndNrorg($Inventory['CDFILIAL'], $nextDay);
        
        if(!empty($paramfilial)){
            //{Entrada}
            $Idfdiaentrest = $paramfilial->getIdfdiaentrest();
            
            if($Idfdiaentrest == 'S' && $booDia == false){
                $NRLANCESTQ = $this->VerifyLancEst($Inventory, ['0','1','2']);
                if(!empty($NRLANCESTQ)){
                    $booDia = true;
                }else{
                    $NRLANCESTQ = $this->VerifyLancEst($Inventory, ['0','1','E']);
                }
                if(!empty($NRLANCESTQ)){
                    $booDia = true;
                }
            }
            
            //{Saída}
            $Idfdiasaidest = $paramfilial->getIdfdiasaidest();
            if($Idfdiasaidest == 'S' && $booDia == false){
                $NRLANCESTQ = $this->VerifyLancEst($Inventory, ['0','1','4']);
                if(!empty($NRLANCESTQ)){
                    $booDia = true;
                }else{
                    $NRLANCESTQ = $this->VerifyLancEst($Inventory, ['0','1','S']);
                }
                if(!empty($NRLANCESTQ)){
                    $booDia = true;
                }
            }
            
            //{Retirada de Estoque}
            $Idfdiaretiest = $paramfilial->getIdfdiaretiest();
            if($Idfdiaretiest == 'S' && $booDia == false){
                $retirada = $this->service->VerifyRetirada($Inventory['CDFILIAL'],$Inventory['DTCONTAGEM']);
                if(!empty($retirada)) $booDia = true;
            }
            
            //{Cardapio}
            $Idfdiacardap = $paramfilial->getIdfdiacardap();
            if($Idfdiacardap == 'S' && $booDia == false){
                $cardapio = $this->VerifyNrCardapio($Inventory);
                
                if(!empty($cardapio)) $booDia = true;
            }
            
            // {Requisição de Estoque}
            $Idfdiaretiest = $paramfilial->getIdfdiaretiest();
            if($Idfdiaretiest == 'S' && $booDia == false){
                $requisicao = $this->service->VerifyRequisition($Inventory['CDFILIAL'],$Inventory['DTCONTAGEM'],"E");
                if(!empty($requisicao)) $booDia = true;
            }
            
            // {Requisição de Planejmento}
            $Idfdiaretiest = $paramfilial->getIdfdiaretiest();
            if($Idfdiaretiest == 'S' && $booDia == false){
                $requisicao = $this->service->VerifyRequisition($Inventory['CDFILIAL'],$Inventory['DTCONTAGEM'],"P");
                if(!empty($requisicao)) $booDia = true;
            }
            
            // {Efetivo de Planejamento}
            $Idfdiaretiest = $paramfilial->getIdfdiaretiest();
            if($Idfdiaretiest == 'S' && $booDia == false){
                $efetivo = $this->service->VerifyEfetive($Inventory['CDFILIAL'],$Inventory['DTCONTAGEM'],"F");
                if(!empty($efetivo)) $booDia = true;
            }
            
            // {Faturamento}
            $Idfdiaretiest = $paramfilial->getIdfdiaretiest();
            if($Idfdiaretiest == 'S' && $booDia == false){
                $efetivo = $this->service->VerifyEfetive($Inventory['CDFILIAL'],$Inventory['DTCONTAGEM'],"P");
                if(!empty($efetivo)) $booDia = true;
            }
        }
        return $booDia;
    }
    
    public function VerifyLancEst($Inventory, $arrIDTPLANCTO) {
        $this->dataSourceName = 'lanctoestoq';
        $newFilterCriteria = new FilterCriteria($this->dataSourceName, []);
        
        $newFilterCriteria->addCondition('CDFILIMOVI', $Inventory['CDFILIAL']);
        $newFilterCriteria->addCondition('DTLANCESTQ', $Inventory['DTCONTAGEM']);
        $newFilterCriteria->addCondition('IDTPLANCTO', $arrIDTPLANCTO, "IN");
        
        $filter = new DTO\Request\Filter($newFilterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        $newResponse = new Response();
        parent::find($filter, $newResponse);
        
        return $newResponse->getDataSets()[0]->getRows();
    }
    
    public function VerifyNrCardapio($Inventory) {
        $this->dataSourceName = 'cardadia';
        $newFilterCriteria = new FilterCriteria($this->dataSourceName, []);
        
        $newFilterCriteria->addCondition('CDFILIAL', $Inventory['CDFILIAL']);
        $newFilterCriteria->addCondition('DTCARDAPIO', $Inventory['DTCONTAGEM']);
        
        $filter = new DTO\Request\Filter($newFilterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        $newResponse = new Response();
        parent::find($filter, $newResponse);
        
        return $newResponse->getDataSets()[0]->getRows();
    }
    
    public function FindData($dataSourceName, $params, $request){
        $this->dataSourceName = $dataSourceName;
        $newFilterCriteria = new FilterCriteria($this->dataSourceName, []);
        
        foreach($params as $Key => $Value) $newFilterCriteria->addCondition($Key, $Value);
        
        $newFilterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($newFilterCriteria);
        $filter = new DTO\Request\Filter($newFilterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        $newResponse = new Response();
        parent::find($filter, $newResponse);
        
        return $newResponse->getDataSets()[0]->getRows();
    }
    
}
